<!DOCTYPE html>
<html>
<head>
	<style type="text/css">
		td{
			width: 2vw;
			height: 2vw;
			text-align: center;
		}
	</style>
	<title>Con objtos en JS</title>
	<script src="js/jquery.js"></script>
	<script type="text/javascript">
		class Celda{
			constructor(){
				this.estado =0;
				this.costo_min =-1;
				this.f_cm; //Fila costo min
				this.c_cm; //Col costo
				this.banderita =false;
			}
			
			costo_minimo(costo,f,c){
				this.costo_min = costo;
				this.f_cm = f;
				this.c_cm = c;
			}

		}
		class Tablero{
			constructor(filas,cols){
				this.tab = Array();
				this.c_filas = filas;
				this.c_cols = cols;
				this.f_f; //fila final
				this.c_f; //col final
				this.f_i;
				this.c_i;
				this.solucion =false;
				this.solucionable = true;
				this.cont_costo_max_actual =0;
				for(var z =0; z < filas; z++){
					this.tab[z] = Array();
					for(var w =0; w < cols; w++){
						this.tab[z][w] = new Celda();
					}
				}
			}
			set_inicio(f,c){
				this.tab[f][c].estado = 2;
				this.tab[f][c].costo_min = 0;
				this.f_i = f;
				this.c_i = c;
			}
			set_final(f,c){
				this.tab[f][c].estado = 3;
				this.f_f = f;
				this.c_f = c;
			}
			set_obstaculo(f,c){
				this.tab[f][c].estado = 1;
			}
			calcular_ruta(){
				this.solucionable =1;
				while(this.tab[this.f_f][this.c_f].costo_min == -1){
					if(!this.paso_a_paso()){
						this.solucionable =0;
						break;
					}					
				}
				if(this.solucionable){
					this.marcar_camino();
				}
							
			}
			marcar_camino(){
				this.solucion = true;
				var pos_temp = [this.f_f,this.c_f];
				while(pos_temp[0] != this.f_i || pos_temp[1] != this.c_i){
					var f_temp = this.tab[pos_temp[0]][pos_temp[1]].f_cm;
					var c_temp = this.tab[pos_temp[0]][pos_temp[1]].c_cm;
					this.tab[pos_temp[0]][pos_temp[1]].banderita = true;
					pos_temp[0] = f_temp;
					pos_temp[1] = c_temp;
				}
			}
			paso_a_paso(){
				for(var f =0; f < this.c_filas; f++){
					for(var c =0; c < this.c_cols; c++){
						if(this.tab[f][c].costo_min == this.cont_costo_max_actual){
							for(var i =0; i < 8; i++){
								var pos_rel = this.posicion_relativa(f,c,i);
								if(pos_rel[0] == -1 || pos_rel[1] == -1){
									continue;
								}else if(typeof this.tab[pos_rel[0]] === 'undefined'){
									continue;
								}else if(typeof this.tab[pos_rel[0]][pos_rel[1]] === 'undefined'){
									continue;
								}else if(this.tab[pos_rel[0]][pos_rel[1]].estado == 1){
									continue;
								}else if(this.tab[pos_rel[0]][pos_rel[1]].costo_min != -1){
									continue;
								}else{
									this.tab[pos_rel[0]][pos_rel[1]].costo_minimo((this.cont_costo_max_actual+1), f, c);
								}
							}
						}
					}
				}
				this.cont_costo_max_actual ++;
				if(this.tab[this.f_f][this.c_f].costo_min != -1){
					this.solucion = 1;
					this.marcar_camino();
				}
				if(this.cont_costo_max_actual > this.c_filas*this.c_cols){
					return 0;
				}else{
					return 1;
				}
			}
			posicion_relativa(f,c,numero){
				var posicion;
				switch(numero){
					case 0:
						posicion = [f-1,c-1];
						break;
					case 1:
						posicion = [f-1,c];
						break;
					case 2:
						posicion = [f-1,c+1];
						break;
					case 3:
						posicion = [f,c-1];
						break;
					case 4:
						posicion = [f,c+1];
						break;
					case 5:
						posicion = [f+1,c-1];
						break;
					case 6:
						posicion = [f+1,c];
						break;
					case 7:
						posicion = [f+1,c+1];
						break;
				}
				return posicion;
			}
			dibujar(){
				var dibujo ="<table>";
				for(var f =0; f < this.c_filas; f++){
					dibujo += "<tr>"
					for(var c=0; c < this.c_cols; c++){
						switch(this.tab[f][c].estado){
							case 0:
								if(!this.tab[f][c].banderita){
									dibujo += "<td style='background-color:grey;'>"+this.tab[f][c].costo_min+"</td>";
								}else{
									dibujo += "<td style='background-color:red;'>"+this.tab[f][c].costo_min+"</td>";
								}
								break;
							case 1: 
								dibujo += "<td style='background-color:black;'>"+this.tab[f][c].costo_min+"</td>";
								break;
							case 2:
								dibujo += "<td style='background-color:green;'>"+this.tab[f][c].costo_min+"</td>";
								break;
							case 3:
								dibujo += "<td style='background-color:blue;'>"+this.tab[f][c].costo_min+"</td>";
								break;
						}
					}
					dibujo += "</tr>";
				}
				dibujo += "</table>";
				if(!this.solucionable){
					dibujo += "<span style='color:red;'>La configuracion seleccionada no cuenta posee ninguna solucion posible</span>";
				}
				return dibujo;
			}
		}
		function setup(){
			var config_inicio =' Cantidad Filas:			<input type="number" id="filas">				Cantidad Columnas:			<input type="number" id="cols">			<input type="button" id="btn" value="Crear">';
			var instrucciones = '				Instrucciones: <br>				&nbsp 1. Ingrese la cantidad de filas y columnas del tablero <br>				&nbsp 2. Presione "Crear" <br>				&nbsp 3. Haga click en la casilla que desea seleccionar como punto \'A\' <br>				&nbsp 4. Haga click en la casilla que desea seleccionar como punto \'B\' <br>				&nbsp 5. Haga click en todas las casillas que desea marcar como obstaculos <br>				&nbsp 6. Presione "Buscar Camino" <br>';
			$("#divi").html(config_inicio);
			$("#instrucciones").html(instrucciones);
			$("#error").html("");
			$("#tabla").html("");
			$("#btn").unbind("click");
			main();
		}
		function main(){
			$("#btn").click(function(){
				var filas = $("#filas").val();
				var cols = $("#cols").val();
				var tabla = "<table>";
				var cont =0;
				var st = Array();
				var fn = Array();
				var obst = Array();
				for(var f =0; f< filas; f++){
					tabla += "<tr>";
					for(var c =0; c < cols; c++){
						tabla += "<td id='"+f+"_"+c+"' class='celda' style='background-color:lightgrey'>&nbsp&nbsp&nbsp&nbsp&nbsp</td>";
					}
					tabla += "</tr>";
				}
				tabla += "</table>";
				tabla += "<input type='button' value='Buscar Camino' id='buscar_camino'>";
				tabla += "<input type='button' value='Resolver de a pasos' id='pp'>";
				$("#tabla").html(tabla);
				$(".celda").click(function(){
					switch(cont){
						case 0:
							st[0] = $(this).attr("id").split("_")[0];
							st[1] = $(this).attr("id").split("_")[1];
							$(this).attr("style","background-color:green");
							cont++;
							break;
						case 1:
							fn[0] = $(this).attr("id").split("_")[0];
							fn[1] = $(this).attr("id").split("_")[1];
							$(this).attr("style","background-color:blue");
							cont++;
							break;
						default:
							var tmp = Array();
							tmp[0] = $(this).attr("id").split("_")[0];
							tmp[1] = $(this).attr("id").split("_")[1];
							if(tmp[0] != st[0] && tmp[1] != st[1] && tmp[0] != fn[0] && tmp[1] != fn[1]){
								obst.push(tmp);
								$(this).attr("style","background-color:black");
								cont++;
							}else{
								$("#error").html("<span style='color:red;'>Los puntos 'A' y 'B' no pueden ser obstaculos</span>");
							}
							break;
					}
				});
				$("#buscar_camino").click(function(){
					$("#divi").html("");
					$("#error").html("");
					if(st.length > 0){
						if(fn.length > 0){
							tablero = new Tablero(filas,cols);
							tablero.set_inicio(st[0],st[1]);
							tablero.set_final(fn[0],fn[1]);
							var cant_obst = obst.length;
							for(var o=0; o < cant_obst; o++){
								tablero.set_obstaculo(obst[o][0],obst[o][1]);
							}
							tablero.calcular_ruta();				
							$("#divi").html(tablero.dibujar()+"<br> <input type='button' value='volver' id='volver' onclick='setup()'>");
							$("#tabla").html("");	
							$("#instrucciones").html("");
						}else{
							$("#error").html("<span style='color:red;'>Elija el punto 'B' </span>");
							//$("#buscar_camino").unbind("click");
						}
					}else{
						$("#error").html("<span style='color:red;'>Elija el punto 'A' </span>");
						//$("#buscar_camino").unbind("click");
					}					
				});
				$("#pp").click(function(){
					$("#divi").html("");
					$("#error").html("");
					$("#instrucciones").html("");
					if(st.length > 0){
						if(fn.length > 0){
							tablero = new Tablero(filas,cols);
							tablero.set_inicio(st[0],st[1]);
							tablero.set_final(fn[0],fn[1]);
							var cant_obst = obst.length;
							for(var o=0; o < cant_obst; o++){
								tablero.set_obstaculo(obst[o][0],obst[o][1]);
							}
											
							$("#divi").html(tablero.dibujar()+"<br> <input type='button' value='volver' id='volver' onclick='setup()'> <input type='button' value='Siguiente' id='siguiente'> <input type='button' value='completar' id='completar'>");
							$("#tabla").html("");	
						}else{
							$("#error").html("<span style='color:red;'>Elija el punto 'B' </span>");
							$("#buscar_camino").unbind("click");
						}
					}else{
						$("#error").html("<span style='color:red;'>Elija el punto 'A' </span>");
						$("#buscar_camino").unbind("click");
					}
					btn_siguiente();
				});
			});
			
			$("#volver").click(function(){
				setup();
			});
		}
		function btn_siguiente(){
			$("#siguiente").click(function(){
				$("#divi").html("");
				tablero.paso_a_paso();
				var temp = tablero.dibujar()+"<br> <input type='button' value='volver' id='volver' onclick='setup()'>";
				if(!tablero.solucion){
					temp += "<input type='button' value='Siguiente' id='siguiente'> <input type='button' value='completar' id='completar'>";
				}
				$("#divi").html(temp);		
				btn_siguiente();				
			});
			btn_completar();
		}
		function btn_completar(){
			$("#completar").click(function(){
				$("#divi").html("");
				tablero.calcular_ruta();
				$("#divi").html(tablero.dibujar()+"<br> <input type='button' value='volver' id='volver' onclick='setup()'>");
			});
		}
		$(document).ready(function(){
			setup();	
		});

	</script>
</head>
<body>
	<div id="divi"></div>
	<div id="error"></div>
	<div id="tabla"></div>
	<div id="instrucciones"></div>

</body>
</html>